###############################################################################

require 'singleton'

###############################################################################

module SC2Cli

###############################################################################

  module Shared

###############################################################################

    class Console

###############################################################################

      include Singleton

###############################################################################

      @@colour_warn  = 3
      @@colour_error = 9

###############################################################################

      def info(message)
        puts(message)
      end

###############################################################################

      def warn(message)
        puts(format(colour: @@colour_warn, message: message))
      end

###############################################################################

      def error(message)
        puts(format(colour: @@colour_error, message: message))
      end

###############################################################################

      def fatal(message)
        error(message)
        exit(1)
      end

###############################################################################

      def format(colour:, message:)
        return "\u001b[38;5;" + colour.to_s + "m" + message + "\u001b[0m"
      end

###############################################################################

    end

###############################################################################

  end

###############################################################################

end

###############################################################################
