###############################################################################

module SC2Cli

###############################################################################

  module Subcommands

###############################################################################

    module LadderShared

###############################################################################

      class LadderDetailsTeams

###############################################################################

        @teams

###############################################################################

        def initialize(json:)
          @teams = Array.new

          json.each do |team|
            team = LadderDetailsTeam.new(json: team)
            add(team: team)
          end
        end

###############################################################################

        def add(team:)
          @teams << team if team.kind_of?(LadderDetailsTeam)
          @teams.sort_by!{ |team| team.points }
        end

###############################################################################

        def count
          return @teams.length
        end

###############################################################################

        def to_s
          result = String.new

          @teams.each do |team|
            result += team.to_s
          end

          return result
        end

###############################################################################

        def with_member(player:)
          result = LadderDetailsTeams.new(json: Array.new)

          @teams.each do |team|
            result.add(team: team) if team.members.has_player(player: player)
          end

          return result
        end

###############################################################################

      end

###############################################################################

    end

###############################################################################

  end

###############################################################################

end

###############################################################################
