###############################################################################

module SC2Cli

###############################################################################

  module Subcommands

###############################################################################

    module LeagueShared

###############################################################################

      class LeagueTiers

###############################################################################

        @tiers

###############################################################################

        attr_reader :colour
        attr_reader :name

###############################################################################

        def initialize(name:, colour:, json:)
          @name   = name
          @colour = colour
          @tiers  = Array.new

          if json.key?("tier") then
            tiers = json["tier"]
            @@console.fatal("Returned league information for: #{name} tiers is not an array!") unless tiers.kind_of?(Array)

            tiers.each do |tier|
              tier = LeagueTier.new(league: @name, colour: @colour, json: tier)
              add(tier: tier)
            end
          end
        end

###############################################################################

        def add(tier:)
          @tiers << tier if tier.kind_of?(LeagueTier)
          @tiers.sort_by!{ |tier| tier.id }
        end

###############################################################################

        def to_s
          result = String.new

          @tiers.each do |tier|
            result += tier.to_s
          end

          return result
        end

###############################################################################

      end

###############################################################################

    end

###############################################################################

  end

###############################################################################

end

###############################################################################
